var ZTBaraSlide = new Class({
	Implements: [Events, Options],
	options:{},
	initialize:function(options){		
		this.setOptions(options);
		this.container = $(this.options.ztContainer);
		this.items = $$(this.options.items);
		this.itemsdesc = $$(this.options.itemsintro); 
		this.pagenav = this.options.pagenav;
		this.current = this.options.currentac;
		this.mainwidth = this.options.mainwidth; 
		this.itemwidth = this.options.itemwidth; 
		this.title = $$(this.options.itemtitle); 
        this.currentIter = this.current;
		if(this.pagenav>0){
			this.pagenext = $$(this.options.pagenext);
			this.pageprev = $$(this.options.pageprev);
			this.pagenext.addEvent('click',function(){this.next(true);}.bind(this));
			this.pageprev.addEvent('click',function(){this.prev(true);}.bind(this));
		} 
        if(this.options.auto==1){
            this.prepareTimer();
        }
		this.items.each(function(item,i){
        	item.addEvent('click',function(event){
        		event = new Event(event);
				if(i!=this.currentIter) { 
					event.stop();
				}
        		this.slideContainer(i);
        	}.bind(this));  
			if(i!=this.current){
				this.items[i].setStyles({
					'top': 35,
					'opacity': 0.2,
					'width': (this.mainwidth-this.itemwidth-10)/2
				});
				this.itemsdesc[i].setStyle('opacity', 0);
				this.title[i].setStyle('opacity', 0);
				this.items[i].removeClass('current');
			}else{
				this.items[i].setStyles({
					'top': 0,
					'opacity': 1,
					'width': this.itemwidth
				});
				this.itemsdesc[i].setStyle('opacity', 1);
				this.title[i].setStyle('opacity', 1);
				this.items[i].addClass('current');
			}
        }.bind(this));
		this.container.setStyle('width', this.items.length*this.itemwidth+'px');
		this.container.setStyle('left', -this.current*((this.mainwidth-this.itemwidth-10)/2));  
		this.maxSlide = this.items.length - 1;
		this.constructElement();
	},
	constructElement: function(){
		this.fxintro = new Fx.Elements(this.items, {transition: this.options.ztTransitions,duration:500,wait:false});
		this.fxdesc = new Fx.Elements(this.itemsdesc, {transition: this.options.ztTransitions,duration:500,wait:false});
		this.fxtitle = new Fx.Elements(this.title, {transition: this.options.ztTransitions,duration:500,wait:false});
		this.fx = new Fx.Morph(this.container, {transition: this.options.ztTransitions,duration:500,wait:false});
		var childrenSlide = this.container.getChildren()[0].getChildren()[0].innerHTML;
		var itemDiv = new Element('div', {'class': 'item'}).set('html',childrenSlide).inject(this.container);
		itemDiv.setStyles({
			'top':'35px', 
			'opacity':'0.2',
			'width':(this.mainwidth-this.itemwidth-10)/2
		});
		var chidrenfinal =  this.container.getChildren()[this.maxSlide].getChildren()[0].innerHTML;
		var itemfinal = new Element('div', {'class': 'item'}).set('html',chidrenfinal).injectTop(this.container);
		itemfinal.setStyles({
			'top':'35px', 
			'opacity':'0.2',
			'width':(this.mainwidth-this.itemwidth-10)/2
		});
	},
	clearTimer:function(){
		$clear(this.timer);
	},
    prepareTimer:function(){
		this.timer = this.next.periodical(this.options.transaction, this);
	},
	goTo:function(num){    	
    	this.clearTimer();     	
    	this.slideContainer(num);    	
        this.prepareTimer();	    	
    },
    slideContainer: function(num){ 
		var obj = {};
		var contentobj = {};
		var titleobj = {};
		this.items.each(function(element,i){
			if(i!=num){
				obj[i] = {
					top: 35,
					width: (this.mainwidth-this.itemwidth-10)/2,
					opacity: 0.2
				};
				contentobj[i] = {opacity: 0};
				titleobj[i] = {opacity: 0};
				this.items[i].removeClass('current');
			}else{
				obj[i] = {
					top: 0,
					width: this.itemwidth,
					opacity:1
				};
				contentobj[i] = {opacity: 1};
				titleobj[i] = {opacity: 1};
				this.items[i].addClass('current');
				this.currentIter = num;
			}
		}.bind(this));
		this.fxtitle.start(titleobj);
		this.fxintro.start(obj);
		this.fx.start({'left':-num*((this.mainwidth-this.itemwidth-10)/2)});
		this.fxdesc.start(contentobj); 
	}, 
	next:function(wait){
		if(this.currentIter==this.maxSlide){ 
			this.currentIter=0;
		}else{ 
			this.currentIter += this.currentIter<this.maxSlide ? 1 : 1-this.maxSlide;
		}
        if(wait){ 
			this.clearTimer();				
        	this.slideContainer(this.currentIter);
            if(this.options.auto==1){
                this.prepareTimer();
            }
        	return; 	
        }                  
        this.goTo(this.currentIter);   
	},
	prev: function(wait){ 
		this.currentIter += this.currentIter>0 ? -1 : this.maxSlide;
        if(wait){ 
			this.clearTimer();				
        	this.slideContainer(this.currentIter);
            if(this.options.auto==1){
                this.prepareTimer();
            }
        	return; 	
        }                  
        this.goTo(this.currentIter);  
	} 
});
ZTBaraSlide.implement(new Events);
ZTBaraSlide.implement(new Options);
