var ZT_TabSlide = new Class({
	Implements: [Events, Options],
	options:{},
	initialize:function(options){		
		this.setOptions(options);
		this.tabcontainer = $$(this.options.ztTabContainer);
		this.items = $$(this.options.items);
		this.itemtab = $$(this.options.itemtab);
        this.ztScrollslide = $$(this.options.ztScrollslide); 
        this.currentIter = 0; 
        this.items.each(function(item,i){
        	item.addEvent('click',function(event){
        		event = new Event(event);        		
        		event.stop();
        		this.goToByClick(i);
        	}.bind(this));        	
        }.bind(this));
		this.itemtab.each(function(item,i){
			if(i!=0){
				item.setStyle('opacity',0);
				item.setStyle('display','block');
			} else {
				item.setStyle('opacity',1);
				item.setStyle('display','block');
			} 
		}.bind(this)); 
		this.ztScrollslide.setStyle('height',this.itemtab[0].getStyle('height'));
		if(this.options.auto==1){
            this.prepareTimer();
        }
	},
	clearTimer:function(){
		$clear(this.timer);
	},
    prepareTimer:function(){
		this.timer = this.next.periodical(this.options.transaction, this);
	},
	goTo:function(num){    	
    	this.clearTimer();     	
    	this.slideContainer(num);    	
        this.prepareTimer();	    	
    },
    slideContainer: function(num){
		zt_tabslide = new Fx.Elements(this.itemtab, {duration:500});
		var obj = {};
		this.itemtab.each(function(item,j){
			if(num!=j){
				this.items[j].removeClass('active');
				obj[j] = {'opacity':0 }; 
			} else {
				this.items[num].addClass('active');
				obj[j] = {'opacity':1}; 
				this.ztScrollslide.setStyle('height',this.itemtab[j].getStyle('height'));
				this.currentIter = num;
			} 
		}.bind(this));
		zt_tabslide.start(obj); 	
	},
	next:function(wait){
		this.nextIter = this.currentIter;
        if (this.nextIter >= this.maxIter)
            this.nextIter = 0;  
        if(wait){ 
			this.clearTimer();				
        	this.slideContainer(this.nextIter);
            if(this.options.auto==1){
                this.prepareTimer();
            }
        	return; 	
        }                  
        this.goTo(this.nextIter);   
	},
	goToByClick:function(num){
		if(num !=this.currentIter) {
			this.clearTimer();				
			this.slideContainer(num);
			if(this.options.auto==1){
				this.prepareTimer();
			}             
		}
	}
});
ZT_TabSlide.implement(new Events);
ZT_TabSlide.implement(new Options);
var ZT_ScrollSlide = new Class({
	Implements: [Events, Options],
	options:{
		duration: 1000,
	    interval: 3000,
		tmpDuration:1000,
		tmpInterval: 3000,
	    autoscroll: 0,
		running: false	
	},
	initialize:function(options){		
		this.setOptions(options); 
		
		this.scrollerWrap = $$(this.options.scrollerWrap);
		this.scrollerItem = $$(this.options.itemscroll);
		this.aryEffect = {};
		this.elements = $$(this.options.itemscroll);
		this.current = 0;
		this.left = $$(this.options.scrollpre);
		this.right = $$(this.options.scrollnext);
		if(this.options.autoscroll) this.nextRun();
		this.left.addEvent('mouseover',function(){
			this.left.addClass('right_active');
			this.scrollClick('right',0);		
			this.options.dir = 'right';			
		}.bind(this));
		this.left.addEvent('mouseleave',function(){
			this.options.dir = 'right';	
			this.scrollClick('right',1);
			this.left.removeClass('right_active');
		}.bind(this));
		this.right.addEvent('mouseover',function(){
			this.options.dir = 'left';	
			this.right.addClass('left_active');
			this.scrollClick('left',0);			
		}.bind(this));
		this.right.addEvent('mouseleave',function(){
			this.options.dir = 'left';							
			this.right.removeClass('left_active');
			this.scrollClick('left',1);
		}.bind(this));
		this.constructElement(); 
	},
	scrollClick:function(dir,mouseleave){
		if(this.options.autoscroll){
			if(mouseleave){
				this.options.interval = this.options.tmpInterval;
				this.options.duration  = this.options.tmpDuration;
			} else {
				this.options.interval = 900;			
				this.options.duration = 500;
				if(mouseleave=='0'){
					this.nextRun();
				}
			}
		} else {
			if(mouseleave){
				this.options.autoscroll = 1;
			} else {
				this.options.interval = 500;			
				this.options.duration = 500;
				this.options.autoscroll = 1;				
				if(mouseleave=='0'){
					this.nextRun();
				}
			}
		}
	},
	nextCurr: function () {	
		if(this.options.dir == 'left') next = (this.current+1) % this.elements.length;		
		else next = (this.current+this.elements.length-1) % this.elements.length;
		return next;
	},
	constructElement:function(){
		for(i=0;i<this.scrollerItem.length;i++){
			this.scrollerItem[i].setStyle('top','0');
			this.scrollerItem[i].setStyle('left',this.options.itemWidth*i);
		}
	},
	getEffect:function(){
		if(this.options.dir == 'left'){
			for(i=0;i<=this.options.noItemDisplay;i++){
				this.aryEffect[i] =	{ 'left': [ i*this.options.itemWidth, (i-1)*this.options.itemWidth] };
			}
		} else {
			for(i=0;i<=this.options.noItemDisplay;i++){
				this.aryEffect[i] =	{ 'left': [ (i-1)*this.options.itemWidth, i*this.options.itemWidth] };
			}
		}
	},
	nextRun: function (isClick) {		
    	if (this.running) return;
		clearTimeout(this.timeOut);
		if (this.options.totalItem <= this.options.noItemDisplay) return;
		if (this.options.autoscroll){
			this.timeOut = setTimeout(this.startEffect.bind(this),this.options.interval);
			this.fetchNext();
		}		
    },
	scrollnext: function () {
		if(this.options.dir =='left') next = (this.current+this.options.noItemDisplay) % this.elements.length;	
		else next = (this.current+this.elements.length-1) % this.elements.length;
		return next;
	},	
	setPosition: function (elems) {
		if (!elems) elems = this.getRunPropertyElems();
        for(i=0;i<elems.length;i++) {
		el = elems[i]; 
		if (el){
			if(this.options.dir == 'left') {
				el.setStyle('left', this.options.itemWidth*i);
			} else {
				el.setStyle('left', this.options.itemWidth*(i-1));
			}					
			}
		}
	},
	startEffect: function () {
		if (!this.elements[this.scrollnext()]) {
			this.nextRun();
			return;
		}
        var objs = this.getRunPropertyElems();	
		this.setPosition(objs);
		if (this.x) this.x.stop();
		this.running = 1;		
        this.x = new Fx.Elements(objs, {duration: this.options.duration, onComplete:this.runcomplete.bind(this)});
		this.getEffect();
		this.x.start(this.aryEffect);
		this.current = this.nextCurr();
    },
	getRunPropertyElems:function(){
		var objEffects = new Array();
		if(this.options.dir == 'right') tmp = 0;
		else tmp = this.elements.length-1;
		for(i=0;i<=this.options.noItemDisplay;i++) {
            objEffects[i] = this.elements[(this.current+i+tmp) % this.elements.length];			
        }
		return objEffects;
	},
	fetchNext: function(){
		this.scrollnext();
	},
    runcomplete: function() {		
    	this.running = 0;
    	this.nextRun();
    }  
});
ZT_ScrollSlide.implement(new Events);
ZT_ScrollSlide.implement(new Options);

/*
var ZT_TabSlide = new Class({
	Implements: [Events, Options],
	options:{},
	initialize:function(options){		
		this.setOptions(options);
		this.tabcontainer = $$(this.options.ztTabContainer);
		this.items = $$(this.options.items);
		this.itemtab = $$(this.options.itemtab);
        this.ztScrollslide = $$(this.options.ztScrollslide);
		
		this.scrollitems = $$(this.options.itemscroll);
		this.mode = this.options.mode || 'horizontal';
		this.modes = {horizontal:['left','width'], vertical:['top','height']};
		this.size = this.options.size || 240;
		this.mainscroll = this.options.mainscroll.setStyle(this.modes[this.mode][1],(this.size*this.scrollitems.length)+'px');
		this.button_event = this.options.button_event || 'click';
		this.handle_event = this.options.handle_event || 'click';
		this.interval = this.options.interval || 5000;
		 
		this.fx = new Fx.Style(this.mainscroll,this.modes[this.mode][0],this.options.fxOptions||{duration:500,wait:false}); 
		this.currentIndex = this.options.startItem || 0;
		this.previousIndex = null;
		this.nextIndex = null;
		this.autoscroll = this.options.autoscroll || false; 
		this._auto = null;
		this.mainscroll.setStyle(this.modes[this.mode][0],(-this.currentIndex*this.size)+'px'); 
		if(this.options.autoscroll) this.play(this.interval,'next',true);
		
        this.currentIter = 0; 
        this.items.each(function(item,i){
        	item.addEvent('click',function(event){
        		event = new Event(event);        		
        		event.stop();
        		this.goToByClick(i);
        	}.bind(this));        	
        }.bind(this));
		this.itemtab.each(function(item,i){
			if(i!=0){
				item.setStyle('opacity',0);
				item.setStyle('display','block');
			} else {
				item.setStyle('opacity',1);
				item.setStyle('display','block');
			} 
		}.bind(this)); 
		this.ztScrollslide.setStyle('height',this.itemtab[0].getStyle('height'));
		if(this.options.auto==1){
            this.prepareTimer();
        }
	},
	clearTimer:function(){
		$clear(this.timer);
	},
    prepareTimer:function(){
		this.timer = this.next.periodical(this.options.transaction, this);
	},
	goTo:function(num){    	
    	this.clearTimer();     	
    	this.slideContainer(num);    	
        this.prepareTimer();	    	
    },
    slideContainer: function(num){
		zt_tabslide = new Fx.Elements(this.itemtab, {duration:500});
		var obj = {};
		this.itemtab.each(function(item,j){
			if(num!=j){
				this.items[j].removeClass('active');
				obj[j] = {'opacity':0 }; 
			} else {
				this.items[num].addClass('active');
				obj[j] = {'opacity':1}; 
				this.ztScrollslide.setStyle('height',this.itemtab[j].getStyle('height'));
				this.currentIter = num;
			} 
		}.bind(this));
		zt_tabslide.start(obj); 	
	},
	play: function(delay,direction,wait){
		this.stop();
		if(!wait){
			this[direction](false);
		}
		this._auto = this[direction].periodical(delay,this,false);
	},
	stop: function(){
		$clear(this._auto);
	},
	previousscroll: function(manual){
		this.currentIndex += this.currentIndex>0 ? -1 : this.scrollitems.length-1;
		this.scrolldirection(null,manual);
	},
	nextscroll: function(manual){ 
		this.currentIndex += this.currentIndex<this.scrollitems.length-1 ? 1 : 1-this.scrollitems.length;
		this.scrolldirection(null,manual);
	},
	scrolldirection: function(item,manual){
		console.log(this.scrollitems.length);
		this.previousIndex = this.currentIndex + (this.currentIndex>0 ? -1 : this.scrollitems.length-1);
		this.nextIndex = this.currentIndex + (this.currentIndex<this.items.length-1 ? 1 : 1-this.scrollitems.length);
		if(manual){ this.stop(); }
		this.fx.start(-this.currentIndex*this.size); 
		if(manual && this.autoPlay){ this.play(this.interval,'next',true); }
	},
	next:function(wait){ 
		this.nextIter = this.currentIter;
        if (this.nextIter >= this.maxIter)
            this.nextIter = 0;  
        if(wait){ 
			this.clearTimer();				
        	this.slideContainer(this.nextIter);
            if(this.options.auto==1){
                this.prepareTimer();
            }
        	return; 	
        }                  
        this.goTo(this.nextIter);   
	},
	goToByClick:function(num){
		if(num !=this.currentIter) {
			this.clearTimer();				
			this.slideContainer(num);
			if(this.options.auto==1){
				this.prepareTimer();
			}             
		}
	},  
	addActionButtons: function(action,buttons){
		for(var i=0; i<buttons.length; i++){
			switch(action){
				case 'previous': buttons[i].addEvent(this.button_event,this.previousscroll.bind(this,true)); break;
				case 'next': buttons[i].addEvent(this.button_event,this.nextscroll.bind(this,true)); break;
			}
		}
	}
});
ZT_TabSlide.implement(new Events);
ZT_TabSlide.implement(new Options);


*/
