<?php
/**
 * @copyright	Copyright (C) 2008 - 2011 ZooTemplate.com. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * See COPYRIGHT.php for copyright notices and details.
 */

// no direct access
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="<?php echo $this->language; ?>" lang="<?php echo $this->language; ?>">
<head>
<jdoc:include type="head" />
<?php JHTML::_('behavior.mootools'); ?>
	<?php
		$document = JFactory::getDocument();
		$document->addStyleSheet($ztTools->baseurl() . 'templates/system/css/system.css');
		$document->addStyleSheet($ztTools->baseurl() . 'templates/system/css/general.css');
		$document->addStyleSheet($ztTools->templateurl() . 'css/default.css');
		$document->addStyleSheet($ztTools->templateurl() . 'css/template.css');
		
		if($ztrtl == 'rtl') {
			$document->addStyleSheet($ztTools->templateurl() . 'css/template_rtl.css');
			$document->addStyleSheet($ztTools->templateurl() . 'css/typo_rtl.css');
		} else {
			$document->addStyleSheet($ztTools->templateurl() . 'css/typo.css');
		}
		
		if($ztTools->getParam('zt_fontfeature')) {
			$document->addStyleSheet($ztTools->templateurl() . 'css/fonts.css');
		}
		
		$document->addScript($ztTools->templateurl() . 'js/zt.script.js');
	?>
	<link rel="stylesheet" href="<?php echo $ztTools->templateurl(); ?>css/modules.css" type="text/css" />
	<link rel="stylesheet" href="<?php echo $ztTools->templateurl(); ?>css/css3.css" type="text/css" />
	<script type="text/javascript">
		var baseurl = "<?php echo $ztTools->baseurl() ; ?>";
		var ztpathcolor = '<?php echo $ztTools->templateurl(); ?>css/colors/';
		var tmplurl = '<?php echo $ztTools->templateurl();?>';
		var CurrentFontSize = parseInt('<?php echo $ztTools->getParam('zt_font');?>');
	</script>
	<link href="<?php echo $ztTools->parse_ztcolor_cookie($ztcolorstyle); ?>" rel="stylesheet" type="text/css" />
	<!--[if lte IE 7]>
	<link rel="stylesheet" href="<?php echo $ztTools->templateurl(); ?>css/ie7.css" type="text/css" />
	<![endif]-->
</head>
<body id="bd" class="fs<?php echo $ztTools->getParam('zt_font'); ?> <?php echo $ztTools->getParam('zt_display'); ?> <?php echo $ztTools->getParam('zt_display_style'); ?> <?php echo $ztrtl; ?>">
<div id="zt-wrapper">
	<div id="zt-wrapper-inner">
		<!--Header-->
		<div id="zt-header">
			<div id="zt-header-top">				
				<div class="zt-wrapper">
					<?php if($this->countModules('top')) : ?>
						<div id="zt-menu-top" class="left">	
							<jdoc:include type="modules" name="top" />
						</div>
					<?php endif; ?>
					
					<?php if($ztTools->getParam('zt_function')) : ?>
						<div id="zt-tool"  class="right"><?php echo $changecolor; ?></div>
					<?php endif; ?>
					<?php if($ztTools->getParam('zt_time')) : ?>
					<div id="zt-time-top" class="right"><?php echo @date('l, F d, Y'); ?></div>
					<?php endif; ?>
				</div>
			</div>	
			<div id="zt-header-banner">				
				<div class="zt-wrapper">
					<div id="zt-header-banner-inner"  class="left">	
						<h1 id="zt-logo" class="left"><a class="png" href="<?php echo $ztTools->baseurl() ; ?>" title="<?php echo $ztTools->sitename() ; ?>">
							<span><?php echo $ztTools->sitename() ; ?></span></a>
						</h1>
					</div>	
				</div>	
			</div>
			<div id="zt-mainmenu">				
				<div class="zt-wrapper">
					<div id="zt-mainmenu-inner<?php echo $zt_menu_width;?>" class="left">
						<?php if($menustyle == 'split') : ?>
						   <?php $menu->show(0,0); ?>
						<?php else : ?>
							<?php $menu->show(); ?>
						<?php endif; ?>
					</div>
					<?php if($this->countModules('search')) : ?>
						<div id="zt-search"  class="right">
							<jdoc:include type="modules" name="search" />
						</div>
					<?php endif; ?>
				</div>	
			</div>
			<?php if (($menustyle == 'split') && ($menu->hasChild(1))): ?>
				<div id="zt-mainmenu-split" class="clearfix">
					<div class="zt-wrapper">
						<div id="split">
							<div class="more-split left">More:</div><?php $menu->show(0, 1,6); ?>
						</div>
					</div>
				</div>
			<?php endif; ?>			
		</div>	
		<!--#Header-->
		
		<!-- UserWapper1 -->
		<?php
			$spotlight1 = array ('user1','user2','user3','user4');
			$botsl1 = $ztTools->calSpotlight($spotlight1,$ztTools->isOP()?100:100, '%');
			if( $botsl1 ) :
		?>	
		<div id="zt-userwrap1" class="clearfix">
			<div class="zt-wrapper">
				<div id="zt-userwrap1-inner">
					<?php if($this->countModules('user1')) : ?>
					<div id="zt-user1" class="zt-user zt-box<?php echo $botsl1['user1']['class']; ?>" style="width: <?php echo $botsl1['user1']['width']; ?>;">
						<div class="zt-box-inside">
							<jdoc:include type="modules" name="user1" style="ztxhtml" />
						</div>
					</div>
					<?php endif; ?>
					<?php if($this->countModules('user2')) : ?>
					<div id="zt-user2" class="zt-user zt-box<?php echo $botsl1['user2']['class']; ?>" style="width: <?php echo $botsl1['user2']['width']; ?>;">
						<div class="zt-box-inside">
							<jdoc:include type="modules" name="user2" style="ztxhtml" />
						</div>
					</div>
					<?php endif; ?>
					<?php if($this->countModules('user3')) : ?>
					<div id="zt-user3" class="zt-user zt-box<?php echo $botsl1['user3']['class']; ?>"  style="width: <?php echo $botsl1['user3']['width']; ?>;">
						<div class="zt-box-inside">
							<jdoc:include type="modules" name="user3" style="ztxhtml" />
						</div>
					</div>
					<?php endif; ?>
					<?php if($this->countModules('user4')) : ?>
					<div id="zt-user4" class="zt-user zt-box<?php echo $botsl1['user4']['class']; ?>"  style="width: <?php echo $botsl1['user4']['width']; ?>;">
						<div class="zt-box-inside">
							<jdoc:include type="modules" name="user4" style="ztxhtml" />
						</div>
					</div>
					<?php endif; ?>
				</div>
			</div>	
		</div>	
		<?php endif; ?>	
		<!-- #UserWapper1 -->
		
		<div id="zt-mainframe" class="clearfix  <?php echo $ztTools->getPageClassSuffix(); ?>">
			<div class="zt-wrapper">
				<div id="zt-mainframe-inner">
					<!-- CONTAINER -->
					<div id="zt-container<?php echo $zt_width; ?>" class="clearfix">
						<div id="zt-content">

							<div id="zt-content-inner"  class="zt-content-inner">
								<div id="zt-middle-inner">	
									<!--laster news-->
									
									<?php if($this->countModules('latestnews')) : ?>
										<div id="zt-laster-news" class="left">	
											<jdoc:include type="modules" name="latestnews" style="ztxhtml" />
										</div>
									<?php endif; ?>
									<?php if($this->countModules('slideshow')) : ?>
										<div id="zt-slideshow" class="right">	
											<jdoc:include type="modules" name="slideshow"/>
										</div>
									<?php endif; ?>
									<?php if($this->countModules('album')) : ?>
										<div id="zt-album">	
											<jdoc:include type="modules" name="album" style="ztxhtml" />
										</div>
									<?php endif; ?>
									<div id="zt-component" class="clearfix">
										<jdoc:include type="message" />
										<jdoc:include type="component" />
									</div>
									<!-- UserWapper2 -->
									<?php
										$spotlight2 = array ('col1','col2','col3');
										$botsl2 = $ztTools->calSpotlight($spotlight2,$ztTools->isOP()?100:100, '%');
										if( $botsl2 ) :
									?>	
									<div id="zt-userwrap2" class="clearfix">
											<div id="zt-userwrap2-inner">
												<?php if($this->countModules('col1')) : ?>
												<div id="zt-col1" class="left zt-col zt-box<?php echo $botsl2['col1']['class']; ?>" style="width: <?php echo $botsl2['col1']['width']; ?>;">
													<div class="zt-box-inside">
														<jdoc:include type="modules" name="col1" style="ztxhtml" />
													</div>
												</div>
												<?php endif; ?>
												<?php if($this->countModules('col2')) : ?>
												<div id="zt-col2" class="left zt-col zt-box<?php echo $botsl2['col2']['class']; ?>" style="width: <?php echo $botsl2['col2']['width']; ?>;">
													<div class="zt-box-inside">
														<jdoc:include type="modules" name="col2" style="ztxhtml" />
													</div>
												</div>
												<?php endif; ?>
												<?php if($this->countModules('col3')) : ?>
												<div id="zt-col3" class="left zt-col zt-box<?php echo $botsl2['col3']['class']; ?>"  style="width: <?php echo $botsl2['col3']['width']; ?>;">
													<div class="zt-box-inside">
														<jdoc:include type="modules" name="col3" style="ztxhtml" />
													</div>
												</div>
												<?php endif; ?>
											</div>
									</div>	
									<?php endif; ?>	
									<!-- #UserWapper2 -->
									<!-- #Wapper News -->
									<?php if($this->countModules('col4')) : ?>
										<div id="zt-news">	
										<jdoc:include type="modules" name="col4" style="ztxhtml" />
										</div>	
									<?php endif; ?>
									<!-- #Wapper News -->
								</div>
							</div>
							<?php   if($this->countModules('right')) : ?>
							<div id="zt-right">
								<div id="zt-right-inner">
								
									<?php
										$col_right = array ('rightcol1','rightcol2');
										$col = $ztTools->calSpotlight($col_right,$ztTools->isOP()?100:96, '%');
										if( $col ) :
									?>	
									<div id="zt-laster-news-right">	
										<?php if($this->countModules('rightcol1')) : ?>
										<div id="zt-rightcol1" class="zt-col zt-box<?php echo $col['rightcol1']['class']; ?> left" style="width: <?php echo $col['rightcol1']['width']; ?>;">
											<div class="zt-box-inside">
												<jdoc:include type="modules" name="rightcol1" style="ztxhtml" />
											</div>
										</div>
										<?php endif; ?>
										<?php if($this->countModules('rightcol2')) : ?>
										<div id="zt-rightcol2" class="zt-col zt-box<?php echo $col['rightcol2']['class']; ?> right" style="width: <?php echo $col['rightcol2']['width']; ?>;">
											<div class="zt-box-inside">
												<jdoc:include type="modules" name="rightcol2" style="ztxhtml" />
											</div>
										</div>
										<?php endif; ?>
									</div>	
									<?php endif; ?>
									
									<jdoc:include type="modules" name="right" style="ztxhtml" />
								</div>
							</div>
							<?php endif; ?>
						</div>
					</div>
					<!-- END CONTAINER -->	
				</div>
			</div>
		</div>
		
		<!-- UserWapper3 -->
		<?php
			$spotlight3 = array ('user5','user6','user7','user8');
			$botsl3 = $ztTools->calSpotlight($spotlight3,$ztTools->isOP()?100:100, '%');
			if( $botsl3 ) :
		?>	
		<div id="zt-userwrap3" class="clearfix">
			<div class="zt-wrapper">
				<div id="zt-userwrap3-inner">
					<?php if($this->countModules('user5')) : ?>
					<div id="zt-user5" class="zt-user zt-box<?php echo $botsl3['user5']['class']; ?>" style="width: <?php echo $botsl3['user5']['width']; ?>;">
						<div class="zt-box-inside">
							<jdoc:include type="modules" name="user5" style="ztxhtml" />
						</div>
					</div>
					<?php endif; ?>
					<?php if($this->countModules('user6')) : ?>
					<div id="zt-user6" class="zt-user zt-box<?php echo $botsl3['user6']['class']; ?>" style="width: <?php echo $botsl3['user6']['width']; ?>;">
						<div class="zt-box-inside">
							<jdoc:include type="modules" name="user6" style="ztxhtml" />
						</div>
					</div>
					<?php endif; ?>
					<?php if($this->countModules('user7')) : ?>
					<div id="zt-user7" class="zt-user zt-box<?php echo $botsl3['user7']['class']; ?>"  style="width: <?php echo $botsl3['user7']['width']; ?>;">
						<div class="zt-box-inside">
							<jdoc:include type="modules" name="user7" style="ztxhtml" />
						</div>
					</div>
					<?php endif; ?>
					<?php if($this->countModules('user8')) : ?>
					<div id="zt-user8" class="zt-user zt-box<?php echo $botsl3['user8']['class']; ?>"  style="width: <?php echo $botsl3['user8']['width']; ?>;">
						<div class="zt-box-inside">
							<jdoc:include type="modules" name="user8" style="ztxhtml" />
						</div>
					</div>
					<?php endif; ?>
				</div>
			</div>	
		</div>	
		<?php endif; ?>	
		<!-- #UserWapper3 -->
		
		<!-- UserWapper4 -->
		<?php
			$spotlight4 = array ('user9','user10','user11','user12');
			$botsl4 = $ztTools->calSpotlight($spotlight4,$ztTools->isOP()?100:100, '%');
			if( $botsl4 ) :
		?>	
		<div id="zt-userwrap4" class="clearfix">
			<div class="zt-wrapper">
				<div id="zt-userwrap4-inner">
					<?php if($this->countModules('user9')) : ?>
					<div id="zt-user9" class="zt-user zt-box<?php echo $botsl4['user9']['class']; ?>" style="width: <?php echo $botsl4['user9']['width']; ?>;">
						<div class="zt-box-inside">
							<jdoc:include type="modules" name="user9" style="ztxhtml" />
						</div>
					</div>
					<?php endif; ?>
					<?php if($this->countModules('user10')) : ?>
					<div id="zt-user10" class="zt-user zt-box<?php echo $botsl4['user10']['class']; ?>" style="width: <?php echo $botsl4['user10']['width']; ?>;">
						<div class="zt-box-inside">
							<jdoc:include type="modules" name="user10" style="ztxhtml" />
						</div>
					</div>
					<?php endif; ?>
					<?php if($this->countModules('user11')) : ?>
					<div id="zt-user11" class="zt-user zt-box<?php echo $botsl4['user11']['class']; ?>"  style="width: <?php echo $botsl4['user11']['width']; ?>;">
						<div class="zt-box-inside">
							<jdoc:include type="modules" name="user11" style="ztxhtml" />
						</div>
					</div>
					<?php endif; ?>
					<?php if($this->countModules('user12')) : ?>
					<div id="zt-user12" class="zt-user zt-box<?php echo $botsl4['user12']['class']; ?>"  style="width: <?php echo $botsl4['user12']['width']; ?>;">
						<div class="zt-box-inside">
							<jdoc:include type="modules" name="user12" style="ztxhtml" />
						</div>
					</div>
					<?php endif; ?>
				</div>
			</div>	
		</div>	
		<?php endif; ?>	
		<!-- #UserWapper4 -->
		
		<!-- footer -->
		<div id="zt-footer" class="clearfix">
			<div class="zt-wrapper">
				<div id="zt-footer-inner">
					<div id="zt-footer-left" class="left">	
						<?php if($ztTools->getParam('zt_footer')) : ?>
						<?php echo $ztTools->getParam('zt_footer_text'); ?>
						<?php else : ?>
						Copyright &copy; 2008 - <?php echo DATE('Y');?> <a href="http://www.zootemplate.com" title="Joomla Templates">Joomla Templates</a> by ZooTemplate.Com. All rights reserved.
						<?php endif; ?>
					</div>
					<?php if($this->countModules('footer')) : ?>
						<div id="zt-footer-menu" class="right">	
							<jdoc:include type="modules" name="footer" />
						</div>		
					<?php endif; ?>	
				</div>
			</div>	
		</div>		
		<!-- #footer -->
		
	</div>
</div>		
<jdoc:include type="modules" name="debug" />
</body>
</html>